'********************************************************
'Monsterbook 2014
'By Bill Elwell
'PIC16f690
'PicBasicPro
'June 28,2014
'Note: MP3 player reads the SD cards allocation table to determine which files is #1 etc.,
'      so files must be added to the SD card one at a time in the order expected.
'      Example: drag and drop the A001.mp3 file first, Then drag and drop the A002.MP3 file second, etc.




'**********************Set Up PIC16f690********************


ansel=0				'No analog
anselh=0			'No analog
cm1con0=0			'No Comparators
cm2con0=0			'No Comparators
adcon0=0			'No analog
trisa=%00000000		'Set all A ports to Outputs
trisb=%01110000		'Set B4,5,6 Inputs,remainder Outputs
trisc=%00000100		'SetC2 input, remainder outputs
INCLUDE "bs1defs.bas"
DEFINE OSC 4		'Oscillator on PIC16f690 internal, 4Mhz. No crystal needed
jaw var portc.3		'Standard Servo
eyes var portc.6	'Micro Servo	
brow var portc.7	'Micro Servo	
mp3 var portb.7		'MDFLY MP3 player
leds var porta.4	'12v LED array for lightning		
motor var portc.5	'not used	
relay var porta.5	'9v relay	
ra var portb.6		'D0 on 4 ch rcvr
rb var portb.5		'D1 on 4 ch rcvr 
rc var portb.4		'D2 on 4 ch rcvr
rd var portc.2		'D3 on 4 ch rcvr
e var word			'used for counters in eye subroutines
b var word			'used for counters in brow subroutines
j var word			'used for counters in jaw subroutines 
a var word			'used for counters in attack subroutine
p var word			'used for counters in purr subroutine
t var word			'used for counters in thunder subroutine
d var word			'used in counters in darth subroutine
bd var word			'baud rate
bd=188				'baud rate set for 4800,8,n,1 for MP3 player

'********************************************************
'initialization
'********************************************************
	high relay		'latch the power	
	low leds		'turn off lightning
	gosub ceyes		'center the eyes
	gosub jawclose	'close the jaw
	gosub cbrow		'center the unibrow
	high mp3		'get ready to send data to the MP3 player
	pause 5000		'Wait for MP3 SD card to be initialized
	gosub ubrow		'Show that initialzation is complete and ready for remote control
	pause 400
	gosub cbrow
	pause 400
	
'********************************************************
'main program
'********************************************************

main:		
			
			if ra=1 then			'Check for "A" button on remote
			gosub purr
			endif
			if rb=1 then			'Check for "B" button on remote
			gosub attack
			endif
			if rc=1 then			'Check for "C" button on remote
			gosub thunder
			endif
			if rd=1 then			'Check for "D" button on remote
			gosub darth
			endif		
			goto main
		
'*************************************************************
'**************	'Routine Launched with "A" button on Remote***
purr:							
				gosub ubrow
				pause 300
				gosub leyes
				pause 200
				gosub dbrow
				pause 400
				gosub reyes
				pause 300
				gosub ubrow
				pause 500
				serout2 mp3,bd,[1]			'Send data to MP3 player, A001.Mp3
				pause 100
				gosub cbrow
				pause 1000
				gosub jawopen
				pause 300
				for p=1 to 8
				gosub jawopen
				pause 500
				gosub jawhalf
				pause 200
				next p
				gosub leyes
				pause 2000
				gosub ceyes
				pause 1000
				gosub ubrow
				pause 2000
				low relay			'Shut all power off
				pause 2000
				return				
				
'*********Routine Launched with "B" button on Remote**************
attack:			gosub jawhalf
				pause 300
				serout2 mp3,bd,[2]		'Send data to MP3 player, A002.Mp3
				gosub jawopen
				pause 1000
				gosub ceyes
				pause 100
				for a=1 to 2
				gosub ubrow
				gosub reyes
				gosub leyes
				gosub dbrow
				pause 200
				next a
				gosub ubrow
				pause 500
				gosub seyes
				pause 1000
				for a=1 to 15
				gosub jawopen
				gosub jawclose
				next a
				pause 2000
				gosub jawopen
				pause 500
				gosub jawclose
				pause 1500
				gosub jawhalf
				gosub jawclose
				pause 1000
				gosub cbrow
				pause 400
				low relay				'Shut all power off
				pause 2000				'Give relay time to drop out
				return

	
'**************Routine Launched with "C" button on Remote*********				
thunder:		
				serout2 mp3,bd,[3]		'Send data to MP3 player, A003.Mp3
				pause 200
				gosub leyes
				gosub reyes
				gosub ceyes 
				gosub ubrow
				gosub jawopen
				pause 1000
				gosub jawopen
				high leds
				pause 400
				low leds
				pause 1000
				gosub jawopen
				gosub jawopen
				gosub jawopen
				gosub jawopen
				gosub jawopen
				for t=1 to 3
				toggle leds
				pause 200
				next t
				low leds
				pause 350
				gosub jawopen
				for t=1 to 15
				toggle leds
				pause 30
				next t
				low leds
				gosub jawopen
				pause 2000
				for t=1 to 4
				toggle leds
				pause 30
				next t
				low leds
				pause 100
				gosub jawopen
				gosub jawopen
				gosub jawopen
				gosub jawopen
				gosub jawopen
				gosub jawopen
				gosub jawopen
				for t=1 to 8
				toggle leds
				pause 30
				next t
				gosub jawclose
				pause 500
				low leds 
				pause 3000
				gosub jawopen
				gosub jawopen
				gosub jawopen
				gosub jawopen
				gosub jawopen
				gosub jawopen
				pause 100
				for t= 1 to 20
				toggle leds
				pause 30
				next t
				gosub jawopen
				gosub jawopen
				gosub jawopen
				gosub jawopen
				gosub jawopen
				gosub jawopen
				gosub jawclose
				pause 1000
				gosub jawopen
				gosub jawopen
				gosub jawopen
				gosub jawopen
				gosub jawopen
				gosub jawopen
				pause 3000
				gosub jawopen
				pause 500
				gosub jawopen
				pause 1000
				gosub jawopen
				pause 300
				gosub jawclose
				pause 12000
				gosub jawopen
				pause 600
				gosub ceyes
				pause 1000
				low relay				'Shut all power off
				pause 3000
				return
						
'*************Routine Launched with "D" button on Remote**********
							
darth:			serout2 mp3,bd,[4]		'Send data to MP3 player, A004.Mp3
				pause 200
				gosub jawopen
				pause 300
				gosub jawopen
				pause 300
				gosub jawopen
				pause 600
				gosub jawopen
				pause 400
				gosub jawopen
				pause 600
				gosub jawopen
				pause 1000
				low relay				'Shut all power off
				pause 2000
				return
				
				
												
'************************************Subroutines below*********************
	
jawopen:		for j=1 to 12			'Servo routine for Jaw Open
				jaw=1
				pauseus 1300
				jaw=0
				pause 16
				next j
				return
				
jawhalf:		for j=1 to 12			'Servo routine for Jaw Half Open
				jaw=1
				pauseus 1000
				jaw=0
				pause 16
				next j
				return				

jawclose:		for j=1 to 12			'Servo routine for Jaw Close
				jaw=1
				pauseus 700
				jaw=0
				pause 16
				next j
				return
			
ceyes:			for e=1 to 12			'Servo routine for Center Eyes
				eyes=1
				pauseus 1500
				eyes=0
				pause 16
				next e
				return

leyes:			for e=1 to 12			'Servo routine for Left Eyes
				eyes=1
				pauseus 1700
				eyes=0
				pause 16
				next e
				return

reyes:			for e=1 to 12			'Servo routine for Right Eyes
				eyes=1
				pauseus 1300
				eyes=0
				pause 16
				next e
				return
				
seyes:			for e=1300 to 1700 step 5		'Servo routine for Slow Eyes
				eyes=1
				pauseus e
				eyes=0
				pause 16
				next e
				for e=1700 to 1300 step -5		
				eyes=1
				pauseus e
				eyes=0
				pause 16
				next e
				for e=1300 to 1500 step 5
				eyes=1
				pauseus e
				eyes=0
				pause 16
				next e
				return												
				

cbrow:			for b=1 to 20				'Servo routine for Center Brow
				brow=1
				pauseus 1500
				brow=0
				pause 16
				next b
				return
				
				

dbrow:			for b=1 to 20				'Servo routine for Brow Down
				brow=1
				pauseus 1900
				brow=0
				pause 16
				next b
				return

ubrow:			for b=1 to 20				'Servo routine for Brow Up
				brow=1
				pauseus 1200
				brow=0
				pause 16
				next b
				return
				

																																